﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO;
using System.Text.RegularExpressions;

namespace AI_Scan_N_Sample_PreTrigger
{
    class Program
    {
        public static bool IsIP(string ip)  //Check the IP format
        {
            return Regex.IsMatch(ip, @"^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$");
        }

        static void Main(string[] args)
        {
            string IP = "";
            bool ret = false;
            bool quitIP = false;
            bool quit = false;
            
            IntPtr hHS;
            IntPtr hcom;

            UInt16[] gVarr = new UInt16[8];
            Int16[] oVarr = new Int16[8];
            short ChCnt = 8;

            string I7Kcom = "COM13,9600,N,8,1";


            short Gain = 0;
            uint ulleng = 0, ulleng1 = 0;
            ushort BufferStatus = 0;
            UInt32 readsize = 0; 

            uint triggerStatus = 0;
            short TrigMode = 3; //pre-trigger
            UInt32 targetCnt = 30000;
            int sampleRate = 30000;

            //unsigned long totalRead=0,totalReceived=0;
            short DataTransMethod = 0;
            short AutoRun = 0;
            int triggerlock = 0;
            float[] FdataBuffer = new float[targetCnt * 8];
            Console.WriteLine("This demo uses I-7088 as a trigger module.\r\nUsers can change the trigger mode by themselves, such as using a signal generator, just remove the part about controlling I-7088 below.");
            while (quitIP == false)
            {
                Console.WriteLine("Please Enter IP!!");
                IP = Console.ReadLine();
                ret = IsIP(IP);
                if (ret == false)
                {
                    Console.WriteLine("Please enter the correct IP");
                }
                else
                {
                    quitIP = true;
                    Thread.Sleep(100);
                }
            }


            hHS = HSDAQNet.Sys.HS_Device_Create(IP);
            if (hHS != IntPtr.Zero)
            {
                Console.WriteLine("ET-7H16 Analog Input Scan Testing [N sample mode & Pre-trigger] using I-7088");
                Console.WriteLine("HSDAQ SDK Ver= " + HSDAQNet.Sys.GetSDKVersion().ToString());
                Console.WriteLine("ET7H16 Firmware Ver= " + HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString());



                hcom = PACNET.UART.Open(I7Kcom);//For I-7088
                PACNET.PWM.SetPWMStart(hcom, PACNET.PAC_IO.PAC_REMOTE_IO(1), 0);    //OFF PWM,For I-7088

                ret = HSDAQNet.HSIO.HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun);



                if (!ret)
                {
                    Console.WriteLine("Error code1 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
                }
                else
                {
                    HSDAQNet.HSIO.HS_GetAIScanParam(hHS, ref ChCnt, ref Gain, ref TrigMode, ref sampleRate, ref targetCnt, ref DataTransMethod, ref AutoRun);
                    Console.WriteLine("Ch=" + ChCnt + ",Gain=" + Gain + ",TrigMode=" + TrigMode + ",sampleRate=" + sampleRate + ",targetCnt=" + targetCnt);

                    ret = HSDAQNet.HSIO.HS_StartAIScan(hHS);
                    if (ret == false)
                    {
                        Console.WriteLine("Error code2 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
                    }
                    Console.WriteLine("Press any key to trigger an external signal....");
                    while (quit == false)
                    {
                        ret = HSDAQNet.HSIO.HS_GetAIBufferStatus(hHS, ref BufferStatus, ref ulleng);


                        if (ret == false)
                        {
                            Console.WriteLine("Error code3 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
                        }
                        else
                        {
                            if (BufferStatus > 2 && (BufferStatus >> 7 & 0x01) != 1) //AI buffer overflow
                            {

                                //  2:  AD_BUF_OVERFLOW	
                                //  4:  AD_SCAN_STOP
                                //  8:  AD_DATA_SAMPLING_TIMEOUT

                                Console.WriteLine("BufferStatus Error<" + BufferStatus + ">," + ulleng);
                                break;
                            }

                            //size = targetCnt;


                            if (ulleng >= targetCnt && BufferStatus>2)
                            {
                                readsize = HSDAQNet.HSIO.HS_GetAIBuffer(hHS, FdataBuffer, ulleng);

                                quit = true;

                            }
                        }
                        /******************This part controls I-7088*********************/
                        if (Console.KeyAvailable && triggerlock == 0)
                        {

                            triggerlock = 1;
                            Thread.Sleep(500);
                            if (hcom == (IntPtr)(-1))
                            {
                                uint ec = PACNET.ErrHandling.GetLastError();
                                Console.WriteLine(((PACNET.ErrCode)ec).ToString() + "I-7088 COM Port open error\r\nError Code: 0x" + ec.ToString("X"));
                            }

                            ret = PACNET.PWM.SetPWMFrequency(hcom, PACNET.PAC_IO.PAC_REMOTE_IO(1), 0, 10000);
                            if (!ret)
                            {
                                uint ec = PACNET.ErrHandling.GetLastError();
                                Console.WriteLine(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
                            }
                            else
                            {
                                PACNET.PWM.SetPWMMode(hcom, PACNET.PAC_IO.PAC_REMOTE_IO(1), 0, 1);
                                PACNET.PWM.SetPWMStart(hcom, PACNET.PAC_IO.PAC_REMOTE_IO(1), 1);    //Start PWM
                                Console.WriteLine("The signal is triggered");
                            }
                            Thread.Sleep(1000);
                            PACNET.PWM.SetPWMStart(hcom, PACNET.PAC_IO.PAC_REMOTE_IO(1), 0);    //OFF PWM

                        }
                        /*****************************************************************/


                        Thread.Sleep(10);

                    }
                    HSDAQNet.HSIO.HS_StopAIScan(hHS);
                    HSDAQNet.Sys.HS_Device_Release(hHS);
                    PACNET.UART.Close(hcom);//For I-7088
                    Console.WriteLine("\r\nAP total read = " + readsize + "\r\n");
                    Console.WriteLine("Press 'Q' to quit program");

                    while (Console.ReadKey(true).Key != ConsoleKey.Q) ;



                }
            }
        }
    }
}
