﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO;
using System.Text.RegularExpressions;

namespace AI_Scan_N_Sample_RMS
{
    class Program
    {
        public static bool IsIP(string ip)  //Check the IP format
        {
            return Regex.IsMatch(ip, @"^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$");
        }

        static void Main(string[] args)
        {
            string IP = "";
            bool ret = false;
            bool quitIP = false;
            bool quit = false;

            IntPtr hHS;
            UInt16 gVal = 0;
            Int16 oVal = 0;

            UInt16[] gVarr = new UInt16[8];
            Int16[] oVarr = new Int16[8];
            short ChCnt = 8;

            short Gain = 1;
            uint ulleng = 0;
            string path = Directory.GetCurrentDirectory();
            short transforRate = 1000;
            short RMSfrequency = 100;

            short TrigMode = 8;
            UInt32 targetCnt = 100;
            int sampleRate = 3000;
            uint triggerStatus = 0;
            short gainVal = 1;

            //unsigned long totalRead=0,totalReceived=0;
            short DataTransMethod = 0;
            short AutoRun = 0;

            while (quitIP == false)
            {
                Console.WriteLine("Please Enter IP!!");
                IP = Console.ReadLine();
                ret = IsIP(IP);
                if (ret == false)
                {
                    Console.WriteLine("Please enter the correct IP");
                }
                else
                {
                    quitIP = true;
                    Thread.Sleep(100);
                }
            }


            hHS = HSDAQNet.Sys.HS_Device_Create(IP);

            if (hHS != IntPtr.Zero)
            {
                Console.WriteLine("HSDAQ SDK Ver= " + HSDAQNet.Sys.GetSDKVersion().ToString());
                Console.WriteLine("ET7H16 Firmware Ver= " + HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString());

                ret = HSDAQNet.HSIO.HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun);
                HSDAQNet.Config.HS_SetConfig(hHS, 5, 0, RMSfrequency); //param = 0 = RMS_SOURCE_BASE
                HSDAQNet.Config.HS_SetConfig(hHS, 5, 1, transforRate); //param = 1 = RMS_TRANSFER_RATE

                if (!ret)
                {
                    Console.WriteLine("Error code1 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
                }
                else
                {
                    HSDAQNet.HSIO.HS_GetAIScanParam(hHS, ref ChCnt, ref Gain, ref TrigMode, ref sampleRate, ref targetCnt, ref DataTransMethod, ref AutoRun);
                    Console.WriteLine("Ch= " + ChCnt + " ,Gain= " + Gain + " ,TrigMode= " + TrigMode + " ,sampleRate= " + sampleRate + " ,targetCnt= " + targetCnt);
                }


                for (int ch = 0; ch < 8; ch++)
                {
                    HSDAQNet.Config.HS_ReadGainOffset(hHS, ch, Gain, ref gVal, ref oVal);

                    gVarr[ch] = gVal;
                    oVarr[ch] = oVal;
                    Console.WriteLine("[ch" + ch + "]Gain = " + gVal + " , Offset = " + oVal);
                }
                for (int i = 0; i < 8; i++)
                {
                    HSDAQNet.Config.HS_SetConfig(hHS, 6, i, Convert.ToInt32(gainVal * 1000));//set RMS gainVal = 1
                }
                Console.WriteLine("-----------------------------------------------------------------");
                Console.WriteLine("Use signal generator to select 200 Hz sine wave, 10Vpp");
                Console.WriteLine("-----------------------------------------------------------------");

                if (!ret)
                {
                    Console.WriteLine("Error code1 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
                }
                else
                {
                    ret = HSDAQNet.DATALOG.HS_StartLogger(hHS, path, 2, 1);
                    if (ret == false)
                    {
                        Console.WriteLine("Error code2 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
                    }

                    while (quit == false)
                    {
                        ret = HSDAQNet.HSIO.HS_GetTotalSamplingStatus(hHS, ref ulleng, ref triggerStatus);
                        if (ret == false)
                        {
                            Console.WriteLine("Error code3 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
                        }
                        else
                        {
                            if (ulleng >= targetCnt && (triggerStatus >> 7) == 1) //N sample mode
                            {
                                Console.WriteLine("\r\nAP total read = " + ulleng.ToString() + "\r\n");
                                quit = true;
                                Thread.Sleep(10);
                                break;
                            }

                        }
                        Thread.Sleep(10);

                    }
                    //Console.WriteLine("1\r\n");
                    Thread.Sleep(1000);
                    HSDAQNet.DATALOG.HS_StopLogger(hHS);
                    //Console.WriteLine("2\r\n");
                    Thread.Sleep(10);
                    HSDAQNet.Sys.HS_Device_Release(hHS);

                }

                IntPtr logconfig = HSDAQNet.DATALOG.HS_LogFile_Open(path);

                Console.WriteLine("Press 'Q' to quit program");
                while (Console.ReadKey(true).Key != ConsoleKey.Q) ;
            }




        }
    }
}
