﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO;
using System.Text.RegularExpressions;

namespace Digital_IO
{
    class Program
    {
        public static bool IsIP(string ip)  //Check the IP format
        {
            return Regex.IsMatch(ip, @"^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$");
        }

        static void Main(string[] args)
        {
            bool quitIP = false;
            bool ret = false;
            bool quit = false;
            string IP = "";
            IntPtr hHS;
            ulong dwDI = 0 , dwDO = 0;

            while (quitIP == false)
            {
                Console.WriteLine("Please Enter IP!!");
                IP = Console.ReadLine();
                ret = IsIP(IP);
                if (ret == false)
                {
                    Console.WriteLine("Please enter the correct IP");
                }
                else
                {
                    quitIP = true;
                    Thread.Sleep(100);
                }
            }

            hHS = HSDAQNet.Sys.HS_Device_Create(IP);

            if (hHS != IntPtr.Zero)
            {
                Console.WriteLine("ET-7H16 Digital I/O Testing");
                Console.WriteLine("HSDAQ SDK Ver= " + HSDAQNet.Sys.GetSDKVersion().ToString());
                Console.WriteLine("ET7H16 Firmware Ver= " + HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString());

                HSDAQNet.IO.ReadDIO(hHS, ref dwDI, ref dwDO);
                Console.WriteLine("Read DI=" + dwDI + " , DO=" + dwDO);
                Console.WriteLine("Write 0x3 to Digital output, press any key to continue...");

                while (quit == false)
                {
                    if (Console.KeyAvailable)
                    {
                        quit = true;
                    }

                }
                HSDAQNet.IO.WriteDO(hHS, 3);

                HSDAQNet.IO.ReadDIO(hHS, ref dwDI, ref dwDO);
                Console.WriteLine("Read DI=" + dwDI + " , DO=" + dwDO);

                HSDAQNet.Sys.HS_Device_Release(hHS);


                Console.WriteLine("Press 'Q' to quit program");
                while (Console.ReadKey(true).Key != ConsoleKey.Q) ;
            }
            

        }
    }
}
