﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO;
using System.Text.RegularExpressions;

namespace ET7H24_Basic_IO
{
    class Program
    {
        public static bool IsIP(string ip)  //Check the IP format
        {
            return Regex.IsMatch(ip, @"^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$");
        }

        static void Main(string[] args)
        {
            bool ret = false, quit = false;
            string IP = "";
            ulong DIval = 0, DOval = 0;
            IntPtr hHS = IntPtr.Zero;
            


            Console.WriteLine("!!This demo is about how to use the DI, DO and AO functions of ET-7H24!!");
            Console.WriteLine("ET-7H24 has 3 DI channel , 4 DO channel , 2 AO channel");
            while (!quit)
            {
                Console.WriteLine("Please Enter IP!!");
                IP = Console.ReadLine();
                ret = IsIP(IP);
                if (ret == false)
                {
                    Console.WriteLine("Please enter the correct IP");
                }
                else
                {
                    quit = true;
                    Thread.Sleep(100);
                }
            }
            quit = false;
            hHS = HSDAQNet.Sys.HS_Device_Create(IP);
            if (hHS == null || hHS == IntPtr.Zero)
            {
                Console.WriteLine("Connect Fail");
                Console.WriteLine("\nPress any key to close...");
                Console.ReadKey();
                return;
            }
            Console.WriteLine("1) Read DI/DO");
            Console.WriteLine("2) Write DO");
            Console.WriteLine("3) Clear DO");
            Console.WriteLine("4) Write AO");
            Console.WriteLine("Q) Quit");
            
            var change = Console.ReadKey();
            switch (change.Key)
            {
                case ConsoleKey.NumPad1:
                case ConsoleKey.D1:
                    //DI
                    HSDAQNet.IO.ReadDIO(hHS,ref DIval,ref DOval);
                    Console.WriteLine("\nDI value : " + DIval);
                    Console.WriteLine("DO value : " + DOval);
                    break;
                case ConsoleKey.NumPad2:
                case ConsoleKey.D2:
                    //DO
                    HSDAQNet.IO.WriteDO(hHS, 7);
                    HSDAQNet.IO.ReadDIO(hHS, ref DIval, ref DOval);
                    Console.WriteLine("\nWrite DO value : " + DOval);
                    HSDAQNet.IO.WriteDO(hHS, 0);
                    int DOch = 1;
                    HSDAQNet.IO.WriteDOBit(hHS, DOch, true);
                    HSDAQNet.IO.ReadDIO(hHS, ref DIval, ref DOval);
                    Console.WriteLine("Write DO bit value : " + DOval);
                    break;
                case ConsoleKey.NumPad3:
                case ConsoleKey.D3:
                    HSDAQNet.IO.WriteDO(hHS, 0);
                    break;
                case ConsoleKey.NumPad4:
                case ConsoleKey.D4:
                    //AO
                    //AOgain
                    //[0] 0 ~ 5 V
                    //[1] 0 ~ 10 V
                    //[2] +/- 5 V
                    //[3] +/- 10 V
                    int AOch = 1;
                    int Aogain = 0;
                    float AOval = (float)2.3;
                    HSDAQNet.IO.WriteAO(hHS, AOch, Aogain, AOval);
                    Console.WriteLine("\nPlease use an electric meter to measure the analog output!");
                    break;
                case ConsoleKey.Q:
                    HSDAQNet.Sys.HS_Device_Release(hHS);
                    return;
            }
            HSDAQNet.Sys.HS_Device_Release(hHS);
            Console.WriteLine("\nPress any key to close...");
            Console.ReadKey();
        }
    }
}
