﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace PET_7H16M_Basic_Function_CS
{
    public partial class Form1 : Form
    {
        IntPtr hHS = IntPtr.Zero;
        
        int AI_range = 0;
        

        Label[] data_arr;
        Label[] data_HEX_arr;
        Label[] gain_arr;
        Label[] offset_arr;
        CheckBox[] DO_Bit_arr;
        ulong do_val = 0;

        [DllImport("kernel32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        static extern bool AllocConsole();

        [DllImport("Kernel32")]
        public static extern void FreeConsole();

        public Form1()
        {
            InitializeComponent();

            AllocConsole();
            ConsoleColor oriColor = Console.ForegroundColor;
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.WriteLine("* Don't close this console window or the application will also close.");
            Console.WriteLine();
            Console.ForegroundColor = oriColor;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i = 0;
            data_arr = new Label[8] { AI0F_lab, AI1F_lab, AI2F_lab, AI3F_lab, AI4F_lab, AI5F_lab, AI6F_lab, AI7F_lab };
            data_HEX_arr = new Label[8] { AI0H_lab, AI1H_lab, AI2H_lab, AI3H_lab, AI4H_lab, AI5H_lab, AI6H_lab, AI7H_lab };
            gain_arr = new Label[8] { C0G_lab, C1G_lab, C2G_lab, C3G_lab, C4G_lab, C5G_lab, C6G_lab, C7G_lab };
            offset_arr = new Label[8] { C0O_lab, C1O_lab, C2O_lab, C3O_lab, C4O_lab, C5O_lab, C6O_lab, C7O_lab };
            DO_Bit_arr = new CheckBox[4] { DO_Bit0_cb, DO_Bit1_cb, DO_Bit2_cb, DO_Bit3_cb };


            Disconnect_btn.Enabled = false;
            HSDAQ_Ver_txt.Enabled = false;
            HSDAQNet_Ver_txt.Enabled = false;
            Firmware_Ver_txt.Enabled = false;
            Hardware_Ver_txt.Enabled = false;
            Module_Name_txt.Enabled = false;

            AI_Range_cmb.Enabled = false;
            AI_Range_cmb.Items.Clear();
            AI_Range_cmb.Items.Add("+/- 5V");
            AI_Range_cmb.Items.Add("+/- 10V");

            Read_AI_btn.Enabled = false;
            Write_DO_btn.Enabled = false;
            DO_Bit0_cb.Enabled = false;
            DO_Bit1_cb.Enabled = false;
            DO_Bit2_cb.Enabled = false;
            DO_Bit3_cb.Enabled = false;
            Read_DI_btn.Enabled = false;


            msg_list.Items.Add("This demo is help for figure out the basic functions like 'read AI', 'read DI', 'write DO'..etc.");
            msg_list.Items.Add("Please input IP address of PET-7H16M and click 'Connect' button.");
        }

        private void connect_btn_Click(object sender, EventArgs e)
        {
            int ch = 0;
            hHS = HSDAQNet.Sys.HS_Device_Create(IP_txt.Text);
            if (hHS == null)
            {
                MessageBox.Show("Invalid IP, please input again.");
            }
            else
            {
                IP_txt.Enabled = false;
                connect_btn.Enabled = false;
                Disconnect_btn.Enabled = true;
                AI_Range_cmb.Enabled = true;
                AI_Range_cmb.SelectedIndex = 0;
                Read_AI_btn.Enabled = true;
                Write_DO_btn.Enabled = true;
                DO_Bit0_cb.Enabled = true;
                DO_Bit1_cb.Enabled = true;
                DO_Bit2_cb.Enabled = true;
                DO_Bit3_cb.Enabled = true;
                Read_DI_btn.Enabled = true;
                HSDAQ_Ver_txt.Text = HSDAQNet.Sys.GetSDKVersion();
                HSDAQNet_Ver_txt.Text = HSDAQNet.Sys.GetHSDAQNetVersion();
                Firmware_Ver_txt.Text = HSDAQNet.Sys.GetFirmwareVersion(hHS);
                Hardware_Ver_txt.Text = HSDAQNet.Sys.GetHWFirmwareVersion(hHS);
                Module_Name_txt.Text = HSDAQNet.Sys.HS_GetModelName(hHS);

                
                
                

                msg_list.Items.Clear();
                msg_list.Items.Add("Connect Successed!!.");
                msg_list.Items.Add("The information about the module and SDK are showed in the 'Information' panel.");
                msg_list.Items.Add("Please try the following IO functions,");
                msg_list.Items.Add("'Read AI' button, 'Write DO' button,'Write DO Bit' checkbox, 'Read DIO' button.");
            }
        }

        private void Disconnect_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            HSDAQNet.Sys.HS_Device_Release(hHS);
            IP_txt.Enabled = true;
            connect_btn.Enabled = true;
            Disconnect_btn.Enabled = false;
            HSDAQ_Ver_txt.Enabled = false;
            HSDAQNet_Ver_txt.Enabled = false;
            Firmware_Ver_txt.Enabled = false;
            Hardware_Ver_txt.Enabled = false;
            AI_Range_cmb.Enabled = false;
            Read_AI_btn.Enabled = false;
            Write_DO_btn.Enabled = false;
            DO_Bit0_cb.Enabled = false;
            DO_Bit1_cb.Enabled = false;
            DO_Bit2_cb.Enabled = false;
            DO_Bit3_cb.Enabled = false;
            Read_DI_btn.Enabled = false;
            for (i = 0; i < 8; i++)
            {
                data_arr[i].Text = "--";
                data_HEX_arr[i].Text = "--";
                gain_arr[i].Text = "--";
                offset_arr[i].Text = "--";
            }
        }

        private void AI_Range_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            Int16 ch = 0;
            ushort gainval = 0;
            short offsetval = 0;
            AI_range = AI_Range_cmb.SelectedIndex;
            for (ch = 0; ch < 8; ch++)
            {
                HSDAQNet.Config.HS_ReadGainOffset(hHS, ch, AI_range, ref gainval, ref offsetval);
                gain_arr[ch].Text = gainval.ToString("X");
                offset_arr[ch].Text = offsetval.ToString("X");
            }
        }

        private void Read_AI_btn_Click(object sender, EventArgs e)
        {
            Int16 ch = 0;
            float fval = 0;
            long hval = 0;
            for (ch = 0; ch < 8; ch++)
            {
                HSDAQNet.IO.ReadAI(hHS, ch, AI_range, ref fval);
                data_arr[ch].Text = fval.ToString();
                HSDAQNet.IO.ReadAIHEX(hHS, ch, AI_range, ref hval);
                data_HEX_arr[ch].Text = hval.ToString("X");
            }
            msg_list.Items.Clear();
            msg_list.Items.Add("PET-7H16M has two different input range.");
            msg_list.Items.Add("Please give it a try on the 'Range' combox.");
            msg_list.Items.Add("And the SDK provide two kind of APIs for read AI.");
            msg_list.Items.Add("One of them reads data in HEX format, and another one reads in float format.");
        }

        private void Write_DO_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            do_val = ulong.Parse(DO_Val_txt.Text, System.Globalization.NumberStyles.HexNumber);
            HSDAQNet.IO.WriteDO(hHS, do_val);
            for (i = 0; i < 4; i++)
            {
                this.DO_Bit_arr[i].CheckedChanged -= new System.EventHandler(this.DO_Bit_Changed);
                if (((do_val >> i) & 0x01) == 1)
                {
                    DO_Bit_arr[i].Checked = true;
                }
                else
                {
                    DO_Bit_arr[i].Checked = false;
                }
                this.DO_Bit_arr[i].CheckedChanged += new System.EventHandler(this.DO_Bit_Changed);
            }
            msg_list.Items.Clear();
            msg_list.Items.Add("The SDK provide two kind of APIs for write DO.");
            msg_list.Items.Add("One of them writes all the DO channels, and another one writes one channel at a time.");
            msg_list.Items.Add("Each bit of 'DO Val' corresponds to one DO channel.(bit 0 : DO0, bit1 : DO1..etc)");
        }

        private void DO_Bit_Changed(object sender, EventArgs e)
        {
            if (((CheckBox)sender).Checked)
            {
                switch (((CheckBox)sender).Name)
                {
                    case "DO_Bit0_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 0, true);
                        do_val |= 0x01;
                        break;
                    case "DO_Bit1_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 1, true);
                        do_val |= 0x02;
                        break;
                    case "DO_Bit2_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 2, true);
                        do_val |= 0x04;
                        break;
                    case "DO_Bit3_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 3, true);
                        do_val |= 0x08;
                        break;
                }
            }
            else
            {
                switch (((CheckBox)sender).Name)
                {
                    case "DO_Bit0_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 0, false);
                        do_val &= ~(ulong)(0x01);
                        break;
                    case "DO_Bit1_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 1, false);
                        do_val &= ~(ulong)(0x02);
                        break;
                    case "DO_Bit2_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 2, false);
                        do_val &= ~(ulong)(0x04);
                        break;
                    case "DO_Bit3_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 3, false);
                        do_val &= ~(ulong)(0x08);
                        break;
                }
            }
            DO_Val_txt.Text = do_val.ToString("X");
        }

        private void Read_DI_btn_Click(object sender, EventArgs e)
        {
            ulong dival = 0;
            ulong doval = 0;
            HSDAQNet.IO.ReadDIO(hHS, ref dival, ref doval);
            DI_Val_txt.Text = dival.ToString("X");
            DO_Val_ReadBack_txt.Text = doval.ToString("X");
            msg_list.Items.Clear();
            msg_list.Items.Add("Each bit of 'DI Val' corresponds to one DI channel.(bit 0 : DI0, bit1 : DI1..etc)");
        }

        private void EXIT_btn_Click(object sender, EventArgs e)
        {
            if (hHS != IntPtr.Zero)
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
            }
            this.Close();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (hHS != IntPtr.Zero)
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
            }
        }
    }
}