﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace PET_7H24M_Basic_Function_CS
{
    public partial class Form1 : Form
    {
        IntPtr hHS = IntPtr.Zero;

        int AI_range = 0;
        int AO0_range = 0;
        int AO1_range = 0;

        Label[] data_arr;
        Label[] data_HEX_arr;
        Label[] gain_arr;
        Label[] offset_arr;
        CheckBox[] DO_Bit_arr;
        ulong do_val = 0;


        [DllImport("kernel32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        static extern bool AllocConsole();

        [DllImport("Kernel32")]
        public static extern void FreeConsole();

        public Form1()
        {
            InitializeComponent();

            AllocConsole();
            ConsoleColor oriColor = Console.ForegroundColor;
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.WriteLine("* Don't close this console window or the application will also close.");
            Console.WriteLine();
            Console.ForegroundColor = oriColor;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i = 0;
            data_arr = new Label[4] { AI0F_lab, AI1F_lab, AI2F_lab, AI3F_lab };
            data_HEX_arr = new Label[4] { AI0H_lab, AI1H_lab, AI2H_lab, AI3H_lab };
            gain_arr = new Label[4] { AI0G_lab, AI1G_lab, AI2G_lab, AI3G_lab };
            offset_arr = new Label[4] { AI0O_lab, AI1O_lab, AI2O_lab, AI3O_lab };
            DO_Bit_arr = new CheckBox[4] { DO_Bit0_cb, DO_Bit1_cb, DO_Bit2_cb, DO_Bit3_cb };

            Disconnect_btn.Enabled = false;
            HSDAQ_Ver_txt.Enabled = false;
            HSDAQNet_Ver_txt.Enabled = false;
            Firmware_Ver_txt.Enabled = false;
            Hardware_Ver_txt.Enabled = false;
            Module_Name_txt.Enabled = false;

            AI_Range_cmb.Enabled = false;
            AI_Range_cmb.Items.Clear();
            AI_Range_cmb.Items.Add("+/- 10V");
            AI_Range_cmb.Items.Add("+/- 5V");
            AI_Range_cmb.Items.Add("+/- 2.5V");
            AI_Range_cmb.Items.Add("+/- 1.25V");
            AI_Range_cmb.Items.Add("+/- 0.625V");
            AI_Range_cmb.Items.Add("+/- 0.30V");
            AI_Range_cmb.Items.Add("+/- 0.15V");
            AI_Range_cmb.Items.Add("+/- 0.075V");
            AI_Range_cmb.Items.Add("+/- 0.040V");
            AI_Range_cmb.Items.Add("+/- 0.020V");

            Read_AI_btn.Enabled = false;

            AO0_Range_cmb.Enabled = false;
            AO0_Range_cmb.Items.Clear();
            AO0_Range_cmb.Items.Add("0 ~ 5V");
            AO0_Range_cmb.Items.Add("0 ~ 10V");
            AO0_Range_cmb.Items.Add("+/- 5V");
            AO0_Range_cmb.Items.Add("+/- 10V");
            Write_AO0_btn.Enabled = false;

            AO1_Range_cmb.Enabled = false;
            AO1_Range_cmb.Items.Clear();
            AO1_Range_cmb.Items.Add("0 ~ 5V");
            AO1_Range_cmb.Items.Add("0 ~ 10V");
            AO1_Range_cmb.Items.Add("+/- 5V");
            AO1_Range_cmb.Items.Add("+/- 10V");
            Write_AO1_btn.Enabled = false;

            AO0F_txt.Enabled = false;
            AO0H_txt.Enabled = false;
            AO1F_txt.Enabled = false;
            AO1H_txt.Enabled = false;

            Write_DO_btn.Enabled = false;
            DO_Bit0_cb.Enabled = false;
            DO_Bit1_cb.Enabled = false;
            DO_Bit2_cb.Enabled = false;
            DO_Bit3_cb.Enabled = false;
            Read_DI_btn.Enabled = false;

            Encoder_Mode_cb.Items.Add("CW/CCW");
            Encoder_Mode_cb.Items.Add("Dir/PLS");
            Encoder_Mode_cb.Items.Add("A/B Phase");

            Encoder_LPF_cb.Items.Add("4 MHz(Disable LPF)");
            Encoder_LPF_cb.Items.Add("3.6 MHz");
            Encoder_LPF_cb.Items.Add("1.8 MHz");
            Encoder_LPF_cb.Items.Add("950 KHz");
            Encoder_LPF_cb.Items.Add("480 KHz");
            Encoder_LPF_cb.Items.Add("240 KHz");
            Encoder_LPF_cb.Items.Add("120 KHz");
            Encoder_LPF_cb.Items.Add("60 KHz");
            Encoder_LPF_cb.Items.Add("30 KHz");

            Encoder_Xor_cb.Items.Add("A axis disable, B axis disable");
            Encoder_Xor_cb.Items.Add("A axis enable,  B axis disable");
            Encoder_Xor_cb.Items.Add("A axis disable, B axis enable");
            Encoder_Xor_cb.Items.Add("A axis enable,  B axis enable");

            Set_Encoder_btn.Enabled = false;
            Read_Encoder_btn.Enabled = false;
            Clear_Encoder_btn.Enabled = false;

            msg_list.Items.Add("This demo is help for figure out the basic functions like 'read AI', 'Write AO' , 'read DI', 'write DO'..etc.");
            msg_list.Items.Add("Please input IP address of PET-7H24M and click 'Connect' button.");
        }

        private void connect_btn_Click(object sender, EventArgs e)
        {
            int ch = 0;
            hHS = HSDAQNet.Sys.HS_Device_Create(IP_txt.Text);
            if (hHS == null)
            {
                MessageBox.Show("Invalid IP, please input again.");
            }
            else
            {
                IP_txt.Enabled = false;
                connect_btn.Enabled = false;
                Disconnect_btn.Enabled = true;
                AI_Range_cmb.Enabled = true;
                AI_Range_cmb.SelectedIndex = 0;
                Read_AI_btn.Enabled = true;

                AO0_Range_cmb.Enabled = true;
                AO0_Range_cmb.SelectedIndex = 0;
                Write_AO0_btn.Enabled = true;

                AO1_Range_cmb.Enabled = true;
                AO1_Range_cmb.SelectedIndex = 0;
                Write_AO1_btn.Enabled = true;

                AO0F_txt.Enabled = true;
                AO0H_txt.Enabled = true;
                AO1F_txt.Enabled = true;
                AO1H_txt.Enabled = true;

                Write_DO_btn.Enabled = true;
                DO_Bit0_cb.Enabled = true;
                DO_Bit1_cb.Enabled = true;
                DO_Bit2_cb.Enabled = true;
                DO_Bit3_cb.Enabled = true;
                Read_DI_btn.Enabled = true;

                Encoder_Mode_cb.SelectedIndex = 0;
                Encoder_LPF_cb.SelectedIndex = 0;
                Encoder_Xor_cb.SelectedIndex = 0;
                Set_Encoder_btn.Enabled = true;
                Read_Encoder_btn.Enabled = true;
                Clear_Encoder_btn.Enabled = true;

                HSDAQ_Ver_txt.Text = HSDAQNet.Sys.GetSDKVersion();
                HSDAQNet_Ver_txt.Text = HSDAQNet.Sys.GetHSDAQNetVersion();
                Firmware_Ver_txt.Text = HSDAQNet.Sys.GetFirmwareVersion(hHS);
                Hardware_Ver_txt.Text = HSDAQNet.Sys.GetHWFirmwareVersion(hHS);
                Module_Name_txt.Text = HSDAQNet.Sys.HS_GetModelName(hHS);

                msg_list.Items.Clear();
                msg_list.Items.Add("Connect Successed!!.");
                msg_list.Items.Add("The information about the module and SDK are showed in the 'Information' panel.");
                msg_list.Items.Add("Please try the following IO functions,");
                msg_list.Items.Add("'Read AI' button, 'Write DO' button,'Write DO Bit' checkbox, 'Read DIO' button.");
            }
        }

        private void Disconnect_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            HSDAQNet.Sys.HS_Device_Release(hHS);
            IP_txt.Enabled = true;
            connect_btn.Enabled = true;
            Disconnect_btn.Enabled = false;
            HSDAQ_Ver_txt.Enabled = false;
            HSDAQNet_Ver_txt.Enabled = false;
            Firmware_Ver_txt.Enabled = false;
            Hardware_Ver_txt.Enabled = false;
            AI_Range_cmb.Enabled = false;
            Read_AI_btn.Enabled = false;

            AO0_Range_cmb.Enabled = false;
            Write_AO0_btn.Enabled = false;

            AO1_Range_cmb.Enabled = false;
            Write_AO1_btn.Enabled = false;

            AO0F_txt.Enabled = false;
            AO0H_txt.Enabled = false;
            AO1F_txt.Enabled = false;
            AO1H_txt.Enabled = false;

            Write_DO_btn.Enabled = false;
            DO_Bit0_cb.Enabled = false;
            DO_Bit1_cb.Enabled = false;
            DO_Bit2_cb.Enabled = false;
            DO_Bit3_cb.Enabled = false;
            Read_DI_btn.Enabled = false;

            Set_Encoder_btn.Enabled = false;
            Read_Encoder_btn.Enabled = false;
            Clear_Encoder_btn.Enabled = false;

            for (i = 0; i < 4; i++)
            {
                data_arr[i].Text = "--";
                data_HEX_arr[i].Text = "--";
                gain_arr[i].Text = "--";
                offset_arr[i].Text = "--";
            }
        }

        private void AI_Range_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            Int16 ch = 0;
            ushort gainval = 0;
            short offsetval = 0;
            AI_range = AI_Range_cmb.SelectedIndex;
            for (ch = 0; ch < 4; ch++)
            {
                HSDAQNet.Config.HS_ReadGainOffset(hHS, ch, AI_range, ref gainval, ref offsetval);
                gain_arr[ch].Text = gainval.ToString("X");
                offset_arr[ch].Text = offsetval.ToString("X");
            }
        }

        private void Read_AI_btn_Click(object sender, EventArgs e)
        {
            Int16 ch = 0;
            float fval = 0;
            long hval = 0;
            for (ch = 0; ch < 4; ch++)
            {
                HSDAQNet.IO.ReadAI(hHS, ch, AI_range, ref fval);
                data_arr[ch].Text = fval.ToString();
                HSDAQNet.IO.ReadAIHEX(hHS, ch, AI_range, ref hval);
                data_HEX_arr[ch].Text = hval.ToString("X");
            }
            msg_list.Items.Clear();
            msg_list.Items.Add("PET-7H24M has twn different input range.");
            msg_list.Items.Add("Please give it a try on the 'Range' combox.");
            msg_list.Items.Add("And the SDK provide two kind of APIs for read AI.");
            msg_list.Items.Add("One of them reads data in HEX format, and another one reads in float format.");
        }

        private void AO0_Range_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            ushort gainval = 0;
            short offsetval = 0;
            AO0_range = AO0_Range_cmb.SelectedIndex;
            HSDAQNet.Config.HS_ReadGainOffset(hHS, 4, AO0_range, ref gainval, ref offsetval);
            AO0G_lab.Text = gainval.ToString("X");
            AO0O_lab.Text = offsetval.ToString("X");
        }

        private void Write_AO0_btn_Click(object sender, EventArgs e)
        {
            // For float format data,
            HSDAQNet.IO.WriteAO(hHS, 0, AO0_Range_cmb.SelectedIndex, float.Parse(AO0F_txt.Text));
            // For HEX format data,
            //HSDAQNet.IO.WriteAOHEX(hHS, 0, AO0_Range_cmb.SelectedIndex, long.Parse(AO0F_txt.Text, System.Globalization.NumberStyles.HexNumber));
        }

        private void AO0_Val_Changed(object sender, EventArgs e)
        {

            if (((TextBox)sender).Name == "AO0F_txt")
            {
                if (((TextBox)sender).Text == "-" || ((TextBox)sender).Text == "")
                {
                    return;
                }
                switch (AO0_range)
                {
                    case 0:
                        this.AO0H_txt.TextChanged -= new System.EventHandler(this.AO0_Val_Changed);
                        AO0H_txt.Text = ((long)(float.Parse(AO0F_txt.Text) / 5 * 0xffff)).ToString("X4");
                        this.AO0H_txt.TextChanged += new System.EventHandler(this.AO0_Val_Changed);
                        break;
                    case 1:
                        this.AO0H_txt.TextChanged -= new System.EventHandler(this.AO0_Val_Changed);
                        AO0H_txt.Text = ((long)(float.Parse(AO0F_txt.Text) / 10 * 0xffff)).ToString("X4");
                        this.AO0H_txt.TextChanged += new System.EventHandler(this.AO0_Val_Changed);
                        break;
                    case 2:
                        this.AO0H_txt.TextChanged -= new System.EventHandler(this.AO0_Val_Changed);
                        AO0H_txt.Text = ((long)((float.Parse(AO0F_txt.Text) + 5) / 10 * 0xffff)).ToString("X4");
                        this.AO0H_txt.TextChanged += new System.EventHandler(this.AO0_Val_Changed);
                        break;
                    case 3:
                        this.AO0H_txt.TextChanged -= new System.EventHandler(this.AO0_Val_Changed);
                        AO0H_txt.Text = ((long)((float.Parse(AO0F_txt.Text) + 10) / 20 * 0xffff)).ToString("X4");
                        this.AO0H_txt.TextChanged += new System.EventHandler(this.AO0_Val_Changed);
                        break;
                }
            }
            else if (((TextBox)sender).Name == "AO0H_txt")
            {
                if (((TextBox)sender).Text == "")
                {
                    return;
                }
                switch (AO0_range)
                {
                    case 0:
                        this.AO0F_txt.TextChanged -= new System.EventHandler(this.AO0_Val_Changed);
                        AO0F_txt.Text = (((float)long.Parse(AO0H_txt.Text, System.Globalization.NumberStyles.HexNumber) / 0xffff * 5)).ToString("F");
                        this.AO0F_txt.TextChanged += new System.EventHandler(this.AO0_Val_Changed);
                        break;
                    case 1:
                        this.AO0F_txt.TextChanged -= new System.EventHandler(this.AO0_Val_Changed);
                        AO0F_txt.Text = (((float)long.Parse(AO0H_txt.Text, System.Globalization.NumberStyles.HexNumber) / 0xffff * 10)).ToString("F");
                        this.AO0F_txt.TextChanged += new System.EventHandler(this.AO0_Val_Changed);
                        break;
                    case 2:
                        this.AO0F_txt.TextChanged -= new System.EventHandler(this.AO0_Val_Changed);
                        AO0F_txt.Text = (((float)long.Parse(AO0H_txt.Text, System.Globalization.NumberStyles.HexNumber) / 0xffff * 10) - 5).ToString("F");
                        this.AO0F_txt.TextChanged += new System.EventHandler(this.AO0_Val_Changed);
                        break;
                    case 3:
                        this.AO0F_txt.TextChanged -= new System.EventHandler(this.AO0_Val_Changed);
                        AO0F_txt.Text = (((float)long.Parse(AO0H_txt.Text, System.Globalization.NumberStyles.HexNumber) / 0xffff * 20) - 10).ToString("F");
                        this.AO0F_txt.TextChanged += new System.EventHandler(this.AO0_Val_Changed);
                        break;
                }
            }
        }

        private void AO1_Range_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            ushort gainval = 0;
            short offsetval = 0;
            AO1_range = AO1_Range_cmb.SelectedIndex;
            HSDAQNet.Config.HS_ReadGainOffset(hHS, 5, AO1_range, ref gainval, ref offsetval);
            AO1G_lab.Text = gainval.ToString("X");
            AO1O_lab.Text = offsetval.ToString("X");
        }

        private void Write_AO1_btn_Click(object sender, EventArgs e)
        {
            // For float format data,
            HSDAQNet.IO.WriteAO(hHS, 1, AO1_Range_cmb.SelectedIndex, float.Parse(AO1F_txt.Text));
            // For HEX format data,
            //HSDAQNet.IO.WriteAOHEX(hHS, 1, AO1_Range_cmb.SelectedIndex, long.Parse(AO1F_txt.Text, System.Globalization.NumberStyles.HexNumber));
        }

        private void AO1_Val_Changed(object sender, EventArgs e)
        {

            if (((TextBox)sender).Name == "AO1F_txt")
            {
                if (((TextBox)sender).Text == "-" || ((TextBox)sender).Text == "")
                {
                    return;
                }
                switch (AO1_range)
                {
                    case 0:
                        this.AO1H_txt.TextChanged -= new System.EventHandler(this.AO1_Val_Changed);
                        AO1H_txt.Text = ((long)(float.Parse(AO1F_txt.Text) / 5 * 0xffff)).ToString("X4");
                        this.AO1H_txt.TextChanged += new System.EventHandler(this.AO1_Val_Changed);
                        break;
                    case 1:
                        this.AO1H_txt.TextChanged -= new System.EventHandler(this.AO1_Val_Changed);
                        AO1H_txt.Text = ((long)(float.Parse(AO1F_txt.Text) / 10 * 0xffff)).ToString("X4");
                        this.AO1H_txt.TextChanged += new System.EventHandler(this.AO1_Val_Changed);
                        break;
                    case 2:
                        this.AO1H_txt.TextChanged -= new System.EventHandler(this.AO1_Val_Changed);
                        AO1H_txt.Text = ((long)((float.Parse(AO1F_txt.Text) + 5) / 10 * 0xffff)).ToString("X4");
                        this.AO1H_txt.TextChanged += new System.EventHandler(this.AO1_Val_Changed);
                        break;
                    case 3:
                        this.AO1H_txt.TextChanged -= new System.EventHandler(this.AO1_Val_Changed);
                        AO1H_txt.Text = ((long)((float.Parse(AO1F_txt.Text) + 10) / 20 * 0xffff)).ToString("X4");
                        this.AO1H_txt.TextChanged += new System.EventHandler(this.AO1_Val_Changed);
                        break;
                }
            }
            else if (((TextBox)sender).Name == "AO1H_txt")
            {
                if (((TextBox)sender).Text == "")
                {
                    return;
                }
                switch (AO1_range)
                {
                    case 0:
                        this.AO1F_txt.TextChanged -= new System.EventHandler(this.AO1_Val_Changed);
                        AO1F_txt.Text = (((float)long.Parse(AO1H_txt.Text, System.Globalization.NumberStyles.HexNumber) / 0xffff * 5)).ToString("F");
                        this.AO1F_txt.TextChanged += new System.EventHandler(this.AO1_Val_Changed);
                        break;
                    case 1:
                        this.AO1F_txt.TextChanged -= new System.EventHandler(this.AO1_Val_Changed);
                        AO1F_txt.Text = (((float)long.Parse(AO1H_txt.Text, System.Globalization.NumberStyles.HexNumber) / 0xffff * 10)).ToString("F");
                        this.AO1F_txt.TextChanged += new System.EventHandler(this.AO1_Val_Changed);
                        break;
                    case 2:
                        this.AO1F_txt.TextChanged -= new System.EventHandler(this.AO1_Val_Changed);
                        AO1F_txt.Text = (((float)long.Parse(AO1H_txt.Text, System.Globalization.NumberStyles.HexNumber) / 0xffff * 10) - 5).ToString("F");
                        this.AO1F_txt.TextChanged += new System.EventHandler(this.AO1_Val_Changed);
                        break;
                    case 3:
                        this.AO1F_txt.TextChanged -= new System.EventHandler(this.AO1_Val_Changed);
                        AO1F_txt.Text = (((float)long.Parse(AO1H_txt.Text, System.Globalization.NumberStyles.HexNumber) / 0xffff * 20) - 10).ToString("F");
                        this.AO1F_txt.TextChanged += new System.EventHandler(this.AO1_Val_Changed);
                        break;
                }
            }
        }

        private void Write_DO_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            do_val = ulong.Parse(DO_Val_txt.Text, System.Globalization.NumberStyles.HexNumber);
            HSDAQNet.IO.WriteDO(hHS, do_val);
            for (i = 0; i < 4; i++)
            {
                this.DO_Bit_arr[i].CheckedChanged -= new System.EventHandler(this.DO_Bit_Changed);
                if (((do_val >> i) & 0x01) == 1)
                {
                    DO_Bit_arr[i].Checked = true;
                }
                else
                {
                    DO_Bit_arr[i].Checked = false;
                }
                this.DO_Bit_arr[i].CheckedChanged += new System.EventHandler(this.DO_Bit_Changed);
            }
            msg_list.Items.Clear();
            msg_list.Items.Add("The SDK provide two kind of APIs for write DO.");
            msg_list.Items.Add("One of them writes all the DO channels, and another one writes one channel at a time.");
            msg_list.Items.Add("Each bit of 'DO Val' corresponds to one DO channel.(bit 0 : DO0, bit1 : DO1..etc)");
        }

        private void DO_Bit_Changed(object sender, EventArgs e)
        {
            if (((CheckBox)sender).Checked)
            {
                switch (((CheckBox)sender).Name)
                {
                    case "DO_Bit0_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 0, true);
                        do_val |= 0x01;
                        break;
                    case "DO_Bit1_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 1, true);
                        do_val |= 0x02;
                        break;
                    case "DO_Bit2_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 2, true);
                        do_val |= 0x04;
                        break;
                    case "DO_Bit3_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 3, true);
                        do_val |= 0x08;
                        break;
                }
            }
            else
            {
                switch (((CheckBox)sender).Name)
                {
                    case "DO_Bit0_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 0, false);
                        do_val &= ~(ulong)(0x01);
                        break;
                    case "DO_Bit1_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 1, false);
                        do_val &= ~(ulong)(0x02);
                        break;
                    case "DO_Bit2_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 2, false);
                        do_val &= ~(ulong)(0x04);
                        break;
                    case "DO_Bit3_cb":
                        HSDAQNet.IO.WriteDOBit(hHS, 3, false);
                        do_val &= ~(ulong)(0x08);
                        break;
                }
            }
            DO_Val_txt.Text = do_val.ToString("X");
        }

        private void Read_DI_btn_Click(object sender, EventArgs e)
        {
            ulong dival = 0;
            ulong doval = 0;
            HSDAQNet.IO.ReadDIO(hHS, ref dival, ref doval);
            DI_Val_txt.Text = dival.ToString("X");
            DO_Val_ReadBack_txt.Text = doval.ToString("X");
            msg_list.Items.Clear();
            msg_list.Items.Add("Each bit of 'DI Val' corresponds to one DI channel.(bit 0 : DI0, bit1 : DI1..etc)");
        }

        private void EXIT_btn_Click(object sender, EventArgs e)
        {
            if (hHS != IntPtr.Zero)
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
            }
            this.Close();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (hHS != IntPtr.Zero)
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
            }
        }

        private void Set_Encoder_btn_Click(object sender, EventArgs e)
        {
            HSDAQNet.IO.HS_SetEncoderMode(hHS, 0, Encoder_Mode_cb.SelectedIndex, Encoder_LPF_cb.SelectedIndex, Encoder_Xor_cb.SelectedIndex);
        }

        private void Read_Encoder_btn_Click(object sender, EventArgs e)
        {
            UInt32 val = 0;
            HSDAQNet.IO.HS_ReadEncoder(hHS, 0, ref val);
            Encoder_value_lab.Text = val.ToString();
        }

        private void Clear_Encoder_btn_Click(object sender, EventArgs e)
        {
            HSDAQNet.IO.HS_ClearEncoder(hHS, 0);
        }
    }
}