﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace PET_7H24M_MagicScan_Buffer_CS
{
    public partial class Form1 : Form
    {
        IntPtr hHS = IntPtr.Zero;

        public CheckBox[] EN_cb_arr;
        public TextBox[] HL_txt_arr;
        public TextBox[] LL_txt_arr;

        int page_idx = 0;
        bool stop = false;

        /*ushort SYNC_PARAM_CNT = 0;
        ushort[] CH_NUMB_arr = new ushort[8] { (ushort)0, (ushort)0, (ushort)0, (ushort)0, (ushort)0, (ushort)0, (ushort)0, (ushort)0 };
        ushort[] CH_TYPE_arr = new ushort[8] { (ushort)0, (ushort)0, (ushort)0, (ushort)0, (ushort)0, (ushort)0, (ushort)0, (ushort)0 };

        UInt32[] Header_Buf = new UInt32[30000000];
        Int32[] HEX32 = new Int32[30000000];
        UInt32[] HEX16 = new UInt32[30000000];
        UInt32[] DICNT_Buf = new UInt32[30000000];
        UInt32[] CNT_Buf = new UInt32[30000000];*/

        [DllImport("kernel32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        static extern bool AllocConsole();

        [DllImport("Kernel32")]
        public static extern void FreeConsole();

        public Form1()
        {
            InitializeComponent();

            AllocConsole();
            ConsoleColor oriColor = Console.ForegroundColor;
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.WriteLine("* Don't close this console window or the application will also close.");
            Console.WriteLine();
            Console.ForegroundColor = oriColor;
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            EN_cb_arr = new CheckBox[4] { C0_cb, C1_cb, C2_cb, C3_cb};
            HL_txt_arr = new TextBox[4] { C0H_txt, C1H_txt, C2H_txt, C3H_txt};
            LL_txt_arr = new TextBox[4] { C0L_txt, C1L_txt, C2L_txt, C3L_txt };

            Trig_Mode_comb.Items.Add("Software Trig");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("AI-Trig");
            Trig_Mode_comb.SelectedIndex = 0;

            Gain_comb.Items.Add("+/- 10V");
            Gain_comb.Items.Add("+/- 5V");
            Gain_comb.Items.Add("+/- 2.5V");
            Gain_comb.Items.Add("+/- 1.25V");
            Gain_comb.Items.Add("+/- 0.625V");
            Gain_comb.Items.Add("+/- 0.30V");
            Gain_comb.Items.Add("+/- 0.15V");
            Gain_comb.Items.Add("+/- 0.075V");
            Gain_comb.Items.Add("+/- 0.040V");
            Gain_comb.Items.Add("+/- 0.020V");
            Gain_comb.SelectedIndex = 0;

            CHs_comb.Items.Add("1 Channel");
            CHs_comb.Items.Add("2 Channels");
            CHs_comb.Items.Add("3 Channels");
            CHs_comb.Items.Add("4 Channels");
            CHs_comb.SelectedIndex = 3;

            AI_Trig_Mode_comb.Items.Add("Above");
            AI_Trig_Mode_comb.Items.Add("Low");
            AI_Trig_Mode_comb.Items.Add("Out-Range");
            AI_Trig_Mode_comb.Items.Add("In-Range");
            AI_Trig_Mode_comb.SelectedIndex = 0;

            this.Size = new System.Drawing.Size(826, 547);

            Disconnect_btn.Enabled = false;
            Magic_Scan_Parameter_gb.Enabled = false;
            Basic_Param_gb.Enabled = false;
            Adv_Param_gb.Enabled = false;
            AI_Trig_gb.Enabled = false;

            Start_Read_gb.Location = new System.Drawing.Point(12, 36);
            Start_Read_gb.Enabled = false;
            Start_Read_gb.Visible = false;

            Start_Magic_Scan_gb.Enabled = false;

            Previous_btn.Enabled = false;
            Next_btn.Enabled = true;
        }

        private void connect_btn_Click(object sender, EventArgs e)
        {
            short chCnt=0, gain=0, externTrig=0, dataTransMethod=0, autorun=0;
            Int32 sampleRate=0;
            UInt32 targetCnt = 0;
            hHS = HSDAQNet.Sys.HS_Device_Create(IP_txt.Text);
            if (hHS == null)
            {
                MessageBox.Show("Invalid IP, please input again.");
            }
            else
            {
                
                HSDAQNet.HSIO.HS_GetAIScanParam(hHS , ref chCnt, ref gain, ref externTrig, ref sampleRate, ref targetCnt, ref dataTransMethod, ref autorun);
                Target_Count_txt.Text = targetCnt.ToString();
                Sample_Rate_txt.Text = sampleRate.ToString();
                CHs_comb.SelectedIndex = chCnt - 1;
                Gain_comb.SelectedIndex = gain;
                Trig_Mode_comb.SelectedIndex = externTrig;

                IP_txt.Enabled = false;
                connect_btn.Enabled = false;
                Disconnect_btn.Enabled = true;

                Basic_Param_gb.Enabled = true;
                Adv_Param_gb.Enabled = true;

                Start_Magic_Scan_gb.Enabled = true;


                if (page_idx == 0)
                {
                    Magic_Scan_Parameter_gb.Enabled = true;
                    Start_Read_gb.Enabled = false;
                    Previous_btn.Enabled = false;
                    Next_btn.Enabled = true;
                }
                else
                {
                    Magic_Scan_Parameter_gb.Enabled = false;
                    Start_Read_gb.Enabled = true;
                    Previous_btn.Enabled = true;
                    Next_btn.Enabled = false;
                }
            }
        }

        private void Disconnect_btn_Click(object sender, EventArgs e)
        {
            HSDAQNet.Sys.HS_Device_Release(hHS);
            connect_btn.Enabled = true;
            Disconnect_btn.Enabled = false;
            Magic_Scan_Parameter_gb.Enabled = false;
            Basic_Param_gb.Enabled = false;
            Adv_Param_gb.Enabled = false;
        }

        private void EXIT_btn_Click(object sender, EventArgs e)
        {
            if (hHS != IntPtr.Zero)
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
            }
            this.Close();
        }

        private void Previous_btn_Click(object sender, EventArgs e)
        {
            if (page_idx == 0)
            {
                return;
            }
            else
            {
                page_idx--;
                Magic_Scan_Parameter_gb.Enabled = true;
                Magic_Scan_Parameter_gb.Visible = true;
                Start_Read_gb.Enabled = false;
                Start_Read_gb.Visible = false;
                Next_btn.Enabled = true;
                Previous_btn.Enabled = false;
            }
        }

        private void Next_btn_Click(object sender, EventArgs e)
        {
            if (page_idx == 0)
            {
                page_idx++;
                Magic_Scan_Parameter_gb.Enabled = false;
                Magic_Scan_Parameter_gb.Visible = false;
                Start_Read_gb.Enabled = true;
                Start_Read_gb.Visible = true;
                Next_btn.Enabled = false;
                Previous_btn.Enabled = true;
            }
            else
            {
                return;
            }
        }

        private void Set_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            int ch = 0;
            byte[] EN_CH_arr = new byte[8] { 0, 0, 0, 0, 0, 0, 0, 0 };
            float[] HL_arr = new float[8];
            float[] LL_arr = new float[8];


            HSDAQNet.HSIO.HS_SetAIScanParam(hHS, (short)(CHs_comb.SelectedIndex + 1), (short)Gain_comb.SelectedIndex, (short)Trig_Mode_comb.SelectedIndex, int.Parse(Sample_Rate_txt.Text), uint.Parse(Target_Count_txt.Text), 0, 0);
            switch (Trig_Mode_comb.SelectedIndex)
            {
                case 0:         //Software Trig
                case 1:         //External Trig
                    break;
                case 2:         //Post
                case 3:         //Pre
                    break;
                case 4:         //Reserved
                    break;
                case 5:         //Delay
                    break;
                case 6:         //AI
                    for (i = 0; i < 4; i++)
                    {
                        if (EN_cb_arr[i].Checked)
                        {
                            EN_CH_arr[i] = 1;
                        }
                        else
                        {
                            EN_CH_arr[i] = 0;
                        }
                        HL_arr[i] = float.Parse(HL_txt_arr[i].Text);
                        LL_arr[i] = float.Parse(LL_txt_arr[i].Text);
                    }
                    Console.WriteLine(AI_Trig_Mode_comb.SelectedIndex + " " + CHs_comb.SelectedIndex + " " + uint.Parse(Left_Count_txt.Text) + " " + uint.Parse(Right_Count_txt.Text));
                    HSDAQNet.HSIO.HS_SetAIAnalogTriggerParam(hHS, AI_Trig_Mode_comb.SelectedIndex, EN_CH_arr, HL_arr, LL_arr, CHs_comb.SelectedIndex + 1, uint.Parse(Left_Count_txt.Text), uint.Parse(Right_Count_txt.Text), 0);
                    break;
            }
        }

        private void Start_btn_Click(object sender, EventArgs e)
        {
            bool ret = false;
            ret = HSDAQNet.HSIO.HS_StartAIScan(hHS);
            if (ret == false)
            {
                MessageBox.Show("Start failed!!!" + "  " + HSDAQNet.ErrHandling.GetLastError());
                HSDAQNet.HSIO.HS_StopAIScan(hHS);
                return;
            }
            switch (uint.Parse(Target_Count_txt.Text))//用targetcnt判斷是否為continue，使用非software mode要注意會出錯
            { 
                case 0:
                    Run_Monitor_continue();
                    break;
                default:
                    Run_Monitor();
                    break;
            }
            
        }

        public void Run_Monitor()
        {
            int t1 = 0, t2 = 0;
            bool ret = false;
            UInt32 Total_Received = 0;
            ushort Receive_status = 0;
            UInt32[] HEX_Data;
            float[] float_Data;
            ushort[] Gain_Value;
            short[] Offset_Value;

            Int32 i = 0;
            int j = 0;
            Int32 Caldata = 0;
            string[] Split_Part = new string[10];


            float[] range=new float[10]{10F,5F,2.5F,1.25F,0.625F,0.3F,0.15F,0.075F,0.04F,0.02F};
	            long lAD_Data;
	            float f=0;

            for (; ; )
            {
                t1 = Environment.TickCount & int.MaxValue;
                ret = HSDAQNet.HSIO.HS_GetAIBufferStatus(hHS, ref Receive_status, ref Total_Received);
                if (ret == false)
                {
                    MessageBox.Show("HS_GetTotalSamplingStatus failed!!! Error Code :  " + HSDAQNet.ErrHandling.GetLastError().ToString("X"));
                    HSDAQNet.HSIO.HS_StopAIScan(hHS);
                    return;
                }
                else
                {
                    if ((Receive_status & 0x20) == 0x20)
                    {
                        MessageBox.Show("Time Out!!! Error Code : " + HSDAQNet.ErrHandling.GetLastError().ToString("X"));
                        HSDAQNet.HSIO.HS_StopAIScan(hHS);
                        break;
                    }
                    else if ((Receive_status & 0x40) == 0x40)
                    {
                        Scan_Status_lab.Text = Receive_status.ToString("X");
                        Scan_Count_lab.Text = "Received Count : " + Total_Received;
                    }
                    else
                    {
                        Scan_Status_lab.Text = Receive_status.ToString("X");
                        Scan_Count_lab.Text = "Sampling Count : " + Total_Received;
                    }
                    if (Trig_Mode_comb.SelectedIndex == 0)
                    {
                        if (int.Parse(Sample_Rate_txt.Text) * (CHs_comb.SelectedIndex + 1) > 60000 * 4)
                        {
                            if (((Receive_status & 0x80) == 0x80 || Total_Received >= uint.Parse(Target_Count_txt.Text) && (Receive_status & 0x80) != 0x00))
                            {
                                HSDAQNet.HSIO.HS_StopAIScan(hHS);
                                t2 = Environment.TickCount & int.MaxValue;
                                Scan_Time_lab.Text = (t2 - t1).ToString();
                                break;
                            }
                        }
                        else
                        {
                            if ((/*(Receive_status & 0x80) == 0x80 &&*/ Total_Received >= uint.Parse(Target_Count_txt.Text)))
                            {
                                HSDAQNet.HSIO.HS_StopAIScan(hHS);
                                t2 = Environment.TickCount & int.MaxValue;
                                Scan_Time_lab.Text = (t2 - t1).ToString();
                                break;
                            }
                        }
                    }
                    else if (Trig_Mode_comb.SelectedIndex == 6)
                    {
                        if ((Receive_status & 0x80) == 0x80)
                        {
                            HSDAQNet.HSIO.HS_StopAIScan(hHS);
                            t2 = Environment.TickCount & int.MaxValue;
                            Scan_Time_lab.Text = (t2 - t1).ToString();
                            break;
                        }
                    }
                    Application.DoEvents();
                }

            }

            HEX_Data = new UInt32[uint.Parse(Target_Count_txt.Text)];
            float_Data = new float[uint.Parse(Target_Count_txt.Text)];

            Gain_Value = new ushort[(CHs_comb.SelectedIndex + 1)];
            Offset_Value = new short[(CHs_comb.SelectedIndex + 1)];
            HSDAQNet.HSIO.HS_GetAIBufferHex(hHS, HEX_Data, uint.Parse(Target_Count_txt.Text));
            for (i = 0; i < (CHs_comb.SelectedIndex + 1); i++)
            {
                HSDAQNet.Config.HS_ReadGainOffset(hHS, i, Gain_comb.SelectedIndex, ref Gain_Value[i], ref Offset_Value[i]);
                Console.WriteLine("gain : " + Gain_Value[i] + " offset : " + Offset_Value[i]);
            }
            for (i = 0; i < uint.Parse(Target_Count_txt.Text); i++)
            {
                HSDAQNet.IO.HS_Calibrate_Data_Float(hHS, i % (CHs_comb.SelectedIndex + 1), Gain_comb.SelectedIndex, (Int32)HEX_Data[i], ref float_Data[i]);
            }

            Data_View_dgv.Rows.Clear();
            Data_View_dgv.ColumnCount = CHs_comb.SelectedIndex + 1 + 1;
            Data_View_dgv.Columns[0].Name = "Index";
            Data_View_dgv.Columns[0].Width = 50;
            for (i = 0; i < (CHs_comb.SelectedIndex + 1); i++)
            {
                Data_View_dgv.Columns[i + 1].Name = "Ch" + i.ToString();
                Data_View_dgv.Columns[i + 1].Width = 75;
                Application.DoEvents();
            }

            for (i = 0; i < int.Parse(Target_Count_txt.Text) / (CHs_comb.SelectedIndex + 1); i++)
            {
                Split_Part[0] = i.ToString();
                for (j = 0; j < (CHs_comb.SelectedIndex + 1); j++)
                {
                    Split_Part[j + 1] = float_Data[i * (CHs_comb.SelectedIndex + 1) + j].ToString();
                }
                Data_View_dgv.Rows.Add(Split_Part);
                Application.DoEvents();
            }

            Console.WriteLine("Finished");
        }

        public void Run_Monitor_continue()
        {
            bool ret = false, quit = false;
            UInt32 Total_Received = 0;
            ushort Receive_status = 0;
            string[] Split_Part = new string[10];
            uint j = 0;


            Data_View_dgv.Rows.Clear();
            Data_View_dgv.ColumnCount = CHs_comb.SelectedIndex + 1 + 1;
            Data_View_dgv.Columns[0].Name = "Index";
            Data_View_dgv.Columns[0].Width = 50;
            Split_Part[0] = "0";
            for (int i = 0; i < (CHs_comb.SelectedIndex + 1); i++)
            {
                Data_View_dgv.Columns[i + 1].Name = "Ch" + i.ToString();
                Data_View_dgv.Columns[i + 1].Width = 75;
                Application.DoEvents();
            }

            while (!quit)
            {
                ushort BufStatus = 0;
                uint BufferCnt = 0;
                HSDAQNet.HSIO.HS_GetAIBufferStatus(hHS, ref Receive_status, ref BufferCnt);

                Scan_Status_lab.Text = Receive_status.ToString("X");
                Scan_Count_lab.Text = Total_Received.ToString();
                if ((BufStatus & 0x20) == 0x20)
                {
                    Console.WriteLine("Error code 0x" + HSDAQNet.ErrHandling.GetLastError().ToString("x8"));
                    HSDAQNet.HSIO.HS_StopAIScan(hHS);
                    break;
                }
                float[] fdatabuf = new float[BufferCnt];
                HSDAQNet.HSIO.HS_GetAIBuffer(hHS, fdatabuf, BufferCnt);
                
                for (int i = 0; i < BufferCnt; i++)
                {
                    /*if ((Total_Received % (CHs_comb.SelectedIndex + 1)) == CHs_comb.SelectedIndex)    //用console顯示
                    {
                        Console.Write("{0}\r\n", fdatabuf[i]);
                    }
                    else
                    {
                        Console.Write("{0},", fdatabuf[i]);
                    }*/

                    Split_Part[Total_Received % (CHs_comb.SelectedIndex + 1) + 1] = fdatabuf[i].ToString();     //用dataGridView顯示
                    if ((Total_Received % (CHs_comb.SelectedIndex + 1)) == CHs_comb.SelectedIndex)
                    {
                        Data_View_dgv.Rows.Add(Split_Part);
                        Split_Part[0] = (++j).ToString();
                    }
                    Total_Received++;
                    Application.DoEvents();
                }
                    
                if (stop == true)
                {
                    quit = true;
                    HSDAQNet.HSIO.HS_StopAIScan(hHS);
                }
            }

            

            
        }

        private void Trig_Mode_comb_SelectedIndexChanged(object sender, EventArgs e)
        {
            AI_Trig_gb.Enabled = false;
            switch (Trig_Mode_comb.SelectedIndex)
            {
                case 0:         //Software Trig
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                    break;
                case 6:
                    AI_Trig_gb.Enabled = true;
                    break;
            }
        }

        private void All_cb_CheckedChanged(object sender, EventArgs e)
        {
            int i = 0;
            for (i = 0; i < 4; i++)
            {
                if (EN_cb_arr[i].Enabled)
                {
                    EN_cb_arr[i].Checked = ((CheckBox)sender).Checked;
                    Application.DoEvents();
                }
            }
        }

        private void AllH_txt_TextChanged(object sender, EventArgs e)
        {
            int i = 0;
            for (i = 0; i < 4; i++)
            {
                if (HL_txt_arr[i].Enabled)
                {
                    HL_txt_arr[i].Text = ((TextBox)sender).Text;
                    Application.DoEvents();
                }
            }
        }

        private void AllL_txt_TextChanged(object sender, EventArgs e)
        {
            int i = 0;
            for (i = 0; i < 4; i++)
            {
                if (LL_txt_arr[i].Enabled)
                {
                    LL_txt_arr[i].Text = ((TextBox)sender).Text;
                    Application.DoEvents();
                }
            }
        }

        private void Stop_btn_Click(object sender, EventArgs e)
        {
            stop = true;
        }
    }
}