﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
namespace PET_AR400_Basic_Function_CS
{
    public partial class Form1 : Form
    {
        IntPtr hHS = IntPtr.Zero;
        Label[] data_float_arr;
        Label[] data_HEX_arr;
        public Form1()
        {
            InitializeComponent();
            data_float_arr = new Label[4] { AI0F_lab, AI1F_lab, AI2F_lab, AI3F_lab };
            data_HEX_arr = new Label[4] { AI0H_lab, AI1H_lab, AI2H_lab, AI3H_lab };
            HSDAQ_Ver_txt.Text = HSDAQNet.Sys.GetSDKVersion();
            HSDAQNet_Ver_txt.Text = HSDAQNet.Sys.GetHSDAQNetVersion();
        }

        private void Connect_btn_Click(object sender, EventArgs e)
        {
            if (Connect_btn.Text == "Connect")
            {
                hHS = HSDAQNet.Sys.HS_Device_Create(IP_txt.Text);
                if (hHS == null)
                {
                    MessageBox.Show("Invalid IP, please input again.");
                }
                else
                {
                    IP_txt.Enabled = false;
                    
                    Connect_btn.Text = "Disconnect";
                    Module_Name_txt.Text = HSDAQNet.Sys.HS_GetModelName(hHS);
                    Firmware_Ver_txt.Text = HSDAQNet.Sys.GetFirmwareVersion(hHS);
                    Hardware_Ver_txt.Text = HSDAQNet.Sys.GetHWFirmwareVersion(hHS);
                    
                }
            }
            else
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
                IP_txt.Enabled = true;
                Connect_btn.Text = "Connect";
            }
        }

        private void EXIT_btn_Click(object sender, EventArgs e)
        {
            if (hHS != IntPtr.Zero)
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
            }
            Close();
        }

        private void Read_AI_btn_Click(object sender, EventArgs e)
        {
            Int16 ch = 0;
            float fval = 0;
            long hval = 0;
            for (ch = 0; ch < 4; ++ch)
            {
                HSDAQNet.IO.ReadAI(hHS, ch, 0/*always 0*/, ref fval);
                data_float_arr[ch].Text = fval.ToString("00.000");
                HSDAQNet.IO.ReadAIHEX(hHS, ch, 0/*always 0*/, ref hval);
                data_HEX_arr[ch].Text = hval.ToString("X");
            }
        }
    }
}
