﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace PET_AR400_MagicScan_Buffer_CS
{
    public partial class Form1 : Form
    {
        IntPtr hHS = IntPtr.Zero;
        public CheckBox[] EN_cb_arr;
        public TextBox[] HL_txt_arr;
        public TextBox[] LL_txt_arr;
        public Form1()
        {
            Int16 i = 0;
            InitializeComponent();
            EN_cb_arr = new CheckBox[4] { C0_cb, C1_cb, C2_cb, C3_cb };
            HL_txt_arr = new TextBox[4] { C0H_txt, C1H_txt, C2H_txt, C3H_txt };
            LL_txt_arr = new TextBox[4] { C0L_txt, C1L_txt, C2L_txt, C3L_txt };
            for (i = 0; i < 4; ++i)
            {
                HL_txt_arr[i].Text = "0";
                LL_txt_arr[i].Text = "0";
            }
            Trig_Mode_comb.Items.Add("Software Trig");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("AI-Trig");
            Trig_Mode_comb.SelectedIndex = 0;
            CHs_comb.Items.Add("1 Channel");
            CHs_comb.Items.Add("2 Channels");
            CHs_comb.Items.Add("3 Channels");
            CHs_comb.Items.Add("4 Channels");
            CHs_comb.SelectedIndex = 3;
            AI_Trig_Mode_comb.Items.Add("Above");
            AI_Trig_Mode_comb.Items.Add("Low");
            AI_Trig_Mode_comb.Items.Add("Out-Range");
            AI_Trig_Mode_comb.Items.Add("In-Range");
            AI_Trig_Mode_comb.SelectedIndex = 0;
            Sample_Rate_txt.Text = "1000";
            Target_Count_txt.Text = "40000";
            MagicScan_tc.Enabled = false;
        }

        private void Connect_btn_Click(object sender, EventArgs e)
        {
            if (Connect_btn.Text == "Connect")
            {
                hHS = HSDAQNet.Sys.HS_Device_Create(IP_txt.Text);
                if (hHS == null)
                {
                    MessageBox.Show("Invalid IP, please input again.");
                }
                else
                {
                    IP_txt.Enabled = false;
                    MagicScan_tc.Enabled = true;
                    Connect_btn.Text = "Disconnect";
                }
            }
            else
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
                IP_txt.Enabled = true;
                Connect_btn.Text = "Connect";
                MagicScan_tc.Enabled = false;
            }
        }

        private void EXIT_btn_Click(object sender, EventArgs e)
        {
            if (hHS != IntPtr.Zero)
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
            }
            Close();
        }

        private void Trig_Mode_comb_SelectedIndexChanged(object sender, EventArgs e)
        {
            AI_Trig_gb.Enabled = false;
            switch (Trig_Mode_comb.SelectedIndex)
            {
                case 0:         //Software Trig
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                    break;
                case 6:
                    AI_Trig_gb.Enabled = true;
                    break;
            }
        }

        private void All_cb_CheckedChanged(object sender, EventArgs e)
        {
            int i = 0;
            for (i = 0; i < 4; i++)
            {
                if (EN_cb_arr[i].Enabled)
                {
                    EN_cb_arr[i].Checked = ((CheckBox)sender).Checked;
                    Application.DoEvents();
                }
            }
        }

        private void AllH_txt_TextChanged(object sender, EventArgs e)
        {
            int i = 0;
            for (i = 0; i < 4; i++)
            {
                if (HL_txt_arr[i].Enabled)
                {
                    HL_txt_arr[i].Text = ((TextBox)sender).Text;
                    Application.DoEvents();
                }
            }
        }

        private void AllL_txt_TextChanged(object sender, EventArgs e)
        {
            int i = 0;
            for (i = 0; i < 4; i++)
            {
                if (LL_txt_arr[i].Enabled)
                {
                    LL_txt_arr[i].Text = ((TextBox)sender).Text;
                    Application.DoEvents();
                }
            }
        }

        private void Set_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            byte[] EN_CH_arr = new byte[8] { 0, 0, 0, 0, 0, 0, 0, 0 };
            float[] HL_arr = new float[8];
            float[] LL_arr = new float[8];
            HSDAQNet.HSIO.HS_SetAIScanParam(hHS, (short)(CHs_comb.SelectedIndex + 1), 0/*Always zero*/, (short)Trig_Mode_comb.SelectedIndex, int.Parse(Sample_Rate_txt.Text), uint.Parse(Target_Count_txt.Text), 0, 0);
            switch (Trig_Mode_comb.SelectedIndex)
            {
                case 0:         //Software Trig
                case 1:         //External Trig
                    break;
                case 2:         //Post
                case 3:         //Pre
                    break;
                case 4:         //Reserved
                    break;
                case 5:         //Delay
                    break;
                case 6:         //AI
                    for (i = 0; i < 4; i++)
                    {
                        if (EN_cb_arr[i].Checked)
                        {
                            EN_CH_arr[i] = 1;
                        }
                        else
                        {
                            EN_CH_arr[i] = 0;
                        }
                        HL_arr[i] = float.Parse(HL_txt_arr[i].Text);
                        LL_arr[i] = float.Parse(LL_txt_arr[i].Text);
                    }
                    HSDAQNet.HSIO.HS_SetAIAnalogTriggerParam(hHS, AI_Trig_Mode_comb.SelectedIndex, EN_CH_arr, HL_arr, LL_arr, CHs_comb.SelectedIndex + 1, uint.Parse(Left_Count_txt.Text), uint.Parse(Right_Count_txt.Text), 0);
                    break;
            }
        }

        private void Start_btn_Click(object sender, EventArgs e)
        {
            bool ret = false;
            ret = HSDAQNet.HSIO.HS_StartAIScan(hHS);
            if (ret == false)
            {
                MessageBox.Show("Start failed!!!" + "  " + HSDAQNet.ErrHandling.GetLastError());
                HSDAQNet.HSIO.HS_StopAIScan(hHS);
                return;
            }
            Run_Monitor();
        }
        public void Run_Monitor()
        {
            int t1 = 0, t2 = 0;
            bool ret = false;
            UInt32 Total_Received = 0;
            ushort Receive_status = 0;
            UInt32[] HEX_Data;
            float[] float_Data;
            ushort[] Gain_Value;
            short[] Offset_Value;
            Int32 i = 0;
            int j = 0;
            Int32 Caldata = 0;
            string[] Split_Part = new string[10];
            float[] range = new float[10] { 10F, 5F, 2.5F, 1.25F, 0.625F, 0.3F, 0.15F, 0.075F, 0.04F, 0.02F };
            long lAD_Data;
            float f = 0;
            t1 = Environment.TickCount & int.MaxValue;
            for (; ; )
            {
                ret = HSDAQNet.HSIO.HS_GetAIBufferStatus(hHS, ref Receive_status, ref Total_Received);
                if (ret == false)
                {
                    MessageBox.Show("HS_GetTotalSamplingStatus failed!!! Error Code :  " + HSDAQNet.ErrHandling.GetLastError().ToString("X"));
                    HSDAQNet.HSIO.HS_StopAIScan(hHS);
                    return;
                }
                else
                {
                    Scan_Status_lab.Text = Receive_status.ToString("X");
                    if ((Receive_status & 0x20) == 0x20)
                    {
                        MessageBox.Show("Time Out!!! Error Code : " + HSDAQNet.ErrHandling.GetLastError().ToString("X"));
                        HSDAQNet.HSIO.HS_StopAIScan(hHS);
                        return;
                    }
                    else if ((Receive_status & 0x40) == 0x40)
                    {
                        Scan_Count_lab.Text = "Received Count : " + Total_Received;
                    }
                    else
                    {
                        Scan_Count_lab.Text = "Sampling Count : " + Total_Received;
                    }
                    if (Trig_Mode_comb.SelectedIndex == 0)
                    {
                        if (int.Parse(Sample_Rate_txt.Text) * (CHs_comb.SelectedIndex + 1) > 43000 * 4)
                        {
                            if ((Receive_status & 0x80) == 0x80 || Total_Received >= uint.Parse(Target_Count_txt.Text))
                            {
                                t2 = Environment.TickCount & int.MaxValue;
                                Scan_Time_lab.Text = (t2 - t1).ToString();
                                break;
                            }
                        }
                        else
                        {
                            if ((Receive_status & 0x80) == 0x80 && Total_Received >= uint.Parse(Target_Count_txt.Text))
                            {
                                t2 = Environment.TickCount & int.MaxValue;
                                Scan_Time_lab.Text = (t2 - t1).ToString();
                                break;
                            }
                        }
                    }
                    else if (Trig_Mode_comb.SelectedIndex == 6)
                    {
                        if ((Receive_status & 0x80) == 0x80)
                        {
                            t2 = Environment.TickCount & int.MaxValue;
                            Scan_Time_lab.Text = (t2 - t1).ToString();
                            break;
                        }
                    }
                    Application.DoEvents();
                }
            }
            float_Data = new float[uint.Parse(Target_Count_txt.Text)];
            HSDAQNet.HSIO.HS_GetAIBuffer(hHS, float_Data, uint.Parse(Target_Count_txt.Text));
            HSDAQNet.HSIO.HS_StopAIScan(hHS);
            Data_View_dgv.Rows.Clear();
            Data_View_dgv.ColumnCount = CHs_comb.SelectedIndex + 1 + 1;
            Data_View_dgv.Columns[0].Name = "Index";
            Data_View_dgv.Columns[0].Width = 50;
            for (i = 0; i < (CHs_comb.SelectedIndex + 1); i++)
            {
                Data_View_dgv.Columns[i + 1].Name = "Ch" + i.ToString();
                Data_View_dgv.Columns[i + 1].Width = 75;
                Application.DoEvents();
            }
            for (i = 0; i < int.Parse(Target_Count_txt.Text) / (CHs_comb.SelectedIndex + 1); i++)
            {
                Split_Part[0] = i.ToString();
                for (j = 0; j < (CHs_comb.SelectedIndex + 1); j++)
                {
                    Split_Part[j + 1] = float_Data[i * (CHs_comb.SelectedIndex + 1) + j].ToString();
                }
                Data_View_dgv.Rows.Add(Split_Part);
                Application.DoEvents();
            }
        }
    }
}
