﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;
namespace PET_AR400_MagicScan_Log_CS
{
    public partial class Form1 : Form
    {
        IntPtr hHS = IntPtr.Zero;
        public CheckBox[] EN_cb_arr;
        public TextBox[] HL_txt_arr;
        public TextBox[] LL_txt_arr;
        [DllImport("kernel32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        static extern bool AllocConsole();
        [DllImport("Kernel32")]
        public static extern void FreeConsole();
        public Form1()
        {
            Int16 i = 0;
            InitializeComponent();
            EN_cb_arr = new CheckBox[4] { C0_cb, C1_cb, C2_cb, C3_cb };
            HL_txt_arr = new TextBox[4] { C0H_txt, C1H_txt, C2H_txt, C3H_txt };
            LL_txt_arr = new TextBox[4] { C0L_txt, C1L_txt, C2L_txt, C3L_txt };
            AllocConsole();
            
            Trig_Mode_comb.Items.Add("Software Trig");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("N/A");
            Trig_Mode_comb.Items.Add("AI-Trig");
            Trig_Mode_comb.SelectedIndex = 0;

            CHs_comb.Items.Add("1 Channel");
            CHs_comb.Items.Add("2 Channels");
            CHs_comb.Items.Add("3 Channels");
            CHs_comb.Items.Add("4 Channels");
            CHs_comb.SelectedIndex = 3;

            Sample_Rate_txt.Text = "1000";
            Target_Count_txt.Text = "40000";

            File_Log_Type_comb.Items.Add("Binary file");
            File_Log_Type_comb.Items.Add("Text file");
            File_Log_Type_comb.Items.Add("Reserved");
            File_Log_Type_comb.Items.Add("TDMS file(float format)");
            File_Log_Type_comb.Items.Add("TDMS file(HEX format)");
            File_Log_Type_comb.SelectedIndex = 0;

            AI_Trig_Mode_comb.Items.Add("Above");
            AI_Trig_Mode_comb.Items.Add("Low");
            AI_Trig_Mode_comb.Items.Add("Out-Range");
            AI_Trig_Mode_comb.Items.Add("In-Range");
            AI_Trig_Mode_comb.SelectedIndex = 0;

            for (i = 0; i < 4; i++)
            {
                EN_cb_arr[i].Checked = true;
                HL_txt_arr[i].Text = "0";
                LL_txt_arr[i].Text = "0";
            }
            All_cb.Checked = true;
            AllH_txt.Text = "0";
            AllL_txt.Text = "0";

            Left_Count_txt.Text = "20000";
            Right_Count_txt.Text = "20000";

            
            Basic_Param_gb.Enabled = false;
            Adv_Param_gb.Enabled = false;
            Start_Magic_Scan_gb.Enabled = false;
        }

        private void Connect_btn_Click(object sender, EventArgs e)
        {
            if (Connect_btn.Text == "Connect")
            {
                hHS = HSDAQNet.Sys.HS_Device_Create(IP_txt.Text);
                if (hHS == null)
                {
                    MessageBox.Show("Invalid IP, please input again.");
                }
                else
                {
                    IP_txt.Enabled = false;
                    
                    Basic_Param_gb.Enabled = true;
                    Adv_Param_gb.Enabled = true;
                    Start_Magic_Scan_gb.Enabled = true;
                    Connect_btn.Text = "Disconnect";
                }
            }
            else
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
                IP_txt.Enabled = true;
                Connect_btn.Text = "Connect";
                Basic_Param_gb.Enabled = false;
                Adv_Param_gb.Enabled = false;
                Start_Magic_Scan_gb.Enabled = false;
            }
        }

        private void EXIT_btn_Click(object sender, EventArgs e)
        {
            if (hHS != IntPtr.Zero)
            {
                HSDAQNet.Sys.HS_Device_Release(hHS);
            }
            Close();
        }

        private void Trig_Mode_comb_SelectedIndexChanged(object sender, EventArgs e)
        {
            AI_Trig_gb.Enabled = false;
            switch (Trig_Mode_comb.SelectedIndex)
            {
                case 0:         //Software Trig
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                    break;
                case 6:
                    AI_Trig_gb.Enabled = true;
                    break;
            }
        }

        private void All_cb_CheckedChanged(object sender, EventArgs e)
        {
            int i = 0;
            for (i = 0; i < 4; i++)
            {
                if (EN_cb_arr[i].Enabled)
                {
                    EN_cb_arr[i].Checked = ((CheckBox)sender).Checked;
                    Application.DoEvents();
                }
            }
        }

        private void AllH_txt_TextChanged(object sender, EventArgs e)
        {
            int i = 0;
            for (i = 0; i < 4; i++)
            {
                if (HL_txt_arr[i].Enabled)
                {
                    HL_txt_arr[i].Text = ((TextBox)sender).Text;
                    Application.DoEvents();
                }
            }
        }

        private void AllL_txt_TextChanged(object sender, EventArgs e)
        {
            int i = 0;
            for (i = 0; i < 4; i++)
            {
                if (LL_txt_arr[i].Enabled)
                {
                    LL_txt_arr[i].Text = ((TextBox)sender).Text;
                    Application.DoEvents();
                }
            }
        }

        private void Set_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            byte[] EN_CH_arr = new byte[8] { 0, 0, 0, 0, 0, 0, 0, 0 };
            float[] HL_arr = new float[8];
            float[] LL_arr = new float[8];
            HSDAQNet.HSIO.HS_SetAIScanParam(hHS, (short)(CHs_comb.SelectedIndex + 1), 0/*Always zero*/, (short)Trig_Mode_comb.SelectedIndex, int.Parse(Sample_Rate_txt.Text), uint.Parse(Target_Count_txt.Text), 0, 0);
            switch (Trig_Mode_comb.SelectedIndex)
            {
                case 0:         //Software Trig
                case 1:         //External Trig
                    break;
                case 2:         //Post
                case 3:         //Pre
                    break;
                case 4:         //Reserved
                    break;
                case 5:         //Delay
                    break;
                case 6:         //AI
                    for (i = 0; i < 4; i++)
                    {
                        if (EN_cb_arr[i].Checked)
                        {
                            EN_CH_arr[i] = 1;
                        }
                        else
                        {
                            EN_CH_arr[i] = 0;
                        }
                        HL_arr[i] = float.Parse(HL_txt_arr[i].Text);
                        LL_arr[i] = float.Parse(LL_txt_arr[i].Text);
                    }
                    HSDAQNet.HSIO.HS_SetAIAnalogTriggerParam(hHS, AI_Trig_Mode_comb.SelectedIndex, EN_CH_arr, HL_arr, LL_arr, CHs_comb.SelectedIndex + 1, uint.Parse(Left_Count_txt.Text), uint.Parse(Right_Count_txt.Text), 0);
                    break;
            }
        }

        private void Start_btn_Click(object sender, EventArgs e)
        {
            bool ret = false;
            ret = HSDAQNet.DATALOG.HS_StartLogger(hHS, System.Environment.CurrentDirectory, 1, File_Log_Type_comb.SelectedIndex);
            if (ret == false)
            {
                MessageBox.Show("Start AIlog failed!!!" + "  " + HSDAQNet.ErrHandling.GetLastError());
                HSDAQNet.DATALOG.HS_StopLogger(hHS);
                return;
            }
            Run_Monitor();
        }

        public void Run_Monitor()
        {
            int t1 = 0, t2 = 0;
            bool ret = false;
            UInt32 Total_Received = 0;
            uint Receive_status = 0;
            for (; ; )
            {
                t1 = Environment.TickCount & int.MaxValue;
                ret = HSDAQNet.HSIO.HS_GetTotalSamplingStatus(hHS, ref Total_Received, ref Receive_status);
                if (ret == false)
                {
                    MessageBox.Show("HS_GetTotalSamplingStatus failed!!! Error Code :  " + HSDAQNet.ErrHandling.GetLastError().ToString("X"));
                    HSDAQNet.DATALOG.HS_StopLogger(hHS);
                    return;
                }
                else
                {
                    Scan_Status_lab.Text = Receive_status.ToString("X");
                    if ((Receive_status & 0x20) == 0x20)
                    {
                        MessageBox.Show("Time Out!!! Error Code : " + HSDAQNet.ErrHandling.GetLastError().ToString("X"));
                        HSDAQNet.DATALOG.HS_StopLogger(hHS);
                        break;
                    }
                    else if ((Receive_status & 0x40) == 0x40)
                    {
                        Scan_Count_lab.Text = "Received Count : " + Total_Received;
                    }
                    else
                    {
                        Scan_Count_lab.Text = "Sampling Count : " + Total_Received;
                    }
                    if (Trig_Mode_comb.SelectedIndex == 0)
                    {
                        if (File_Log_Type_comb.SelectedIndex == 0)
                        {
                            if (int.Parse(Sample_Rate_txt.Text) * (CHs_comb.SelectedIndex + 1) > 60000)
                            {
                                if ((Receive_status & 0x80) == 0x80 || Total_Received >= uint.Parse(Target_Count_txt.Text) && (Receive_status & 0x80) != 0x00)
                                {
                                    HSDAQNet.DATALOG.HS_StopLogger(hHS);
                                    t2 = Environment.TickCount & int.MaxValue;
                                    Scan_Time_lab.Text = (t2 - t1).ToString();
                                    break;
                                }
                            }
                            else
                            {
                                if ((Receive_status & 0x80) == 0x80 && Total_Received >= uint.Parse(Target_Count_txt.Text))
                                {
                                    HSDAQNet.DATALOG.HS_StopLogger(hHS);
                                    t2 = Environment.TickCount & int.MaxValue;
                                    Scan_Time_lab.Text = (t2 - t1).ToString();
                                    break;
                                }
                            }
                        }
                        else if (File_Log_Type_comb.SelectedIndex == 1)
                        {
                            if (int.Parse(Sample_Rate_txt.Text) * (CHs_comb.SelectedIndex + 1) > 60000)
                            {
                                if ((Receive_status & 0x80) == 0x80 || Total_Received >= uint.Parse(Target_Count_txt.Text) && (Receive_status & 0x80) != 0x00)
                                {
                                    HSDAQNet.DATALOG.HS_StopLogger(hHS);
                                    t2 = Environment.TickCount & int.MaxValue;
                                    Scan_Time_lab.Text = (t2 - t1).ToString();
                                    break;
                                }
                            }
                            else
                            {
                                if ((Receive_status & 0x80) == 0x80 && Total_Received >= uint.Parse(Target_Count_txt.Text))
                                {
                                    HSDAQNet.DATALOG.HS_StopLogger(hHS);
                                    t2 = Environment.TickCount & int.MaxValue;
                                    Scan_Time_lab.Text = (t2 - t1).ToString();
                                    break;
                                }
                            }
                        }
                        else if (File_Log_Type_comb.SelectedIndex == 3 || File_Log_Type_comb.SelectedIndex == 4)
                        {
                            if ((Receive_status & 0x80) == 0x80 && Total_Received >= uint.Parse(Target_Count_txt.Text))
                            {
                                HSDAQNet.DATALOG.HS_StopLogger(hHS);
                                t2 = Environment.TickCount & int.MaxValue;
                                Scan_Time_lab.Text = (t2 - t1).ToString();
                                break;
                            }
                        }
                    }
                    else if (Trig_Mode_comb.SelectedIndex == 6)
                    {
                        if ((Receive_status & 0x80) == 0x80)
                        {
                            HSDAQNet.DATALOG.HS_StopLogger(hHS);
                            t2 = Environment.TickCount & int.MaxValue;
                            Scan_Time_lab.Text = (t2 - t1).ToString();
                            break;
                        }
                    }
                    Application.DoEvents();
                }
            }
        }

        private void Open_File_btn_Click(object sender, EventArgs e)
        {
            OpenFileDialog Log_File = new OpenFileDialog();
            IntPtr hFile = IntPtr.Zero;
            Int32[] HEX_Data;
            float[] float_Data;
            UInt32 fileLength = 0;

            string name = "";
            int filetype = 0;
            int fileversion = 0;

            short CHs = 0;
            short gain = 0;
            short mode = 0;
            int rate = 0;
            short transmode = 0;
            short sync = 0;

            ushort[] Gain_Value;
            short[] Offset_Value;

            UInt32 sample_cnt = 0;
            string date = "";
            string time = "";

            Int32 i = 0;
            int j = 0;
            
            float[] range = new float[10] { 10F, 5F, 2.5F, 1.25F, 0.625F, 0.3F, 0.15F, 0.075F, 0.04F, 0.02F };
            string[] Split_Part = new string[9];

            Log_File.Title = "Open Log file";
            Log_File.InitialDirectory = System.IO.Directory.GetCurrentDirectory();
            Log_File.Filter = "all files(*.*)|*.*|bin files(*.bin)|*.bin|txt files(*.txt)|*txt|TDMS  files(*.tdm)|*tdm";
            Log_File.FileName = "";
            Log_File.AddExtension = true;
            Log_File.CheckFileExists = false;
            if (Log_File.ShowDialog() == DialogResult.OK)
            {
                hFile = HSDAQNet.DATALOG.HS_LogFile_Open(Log_File.FileName);
                
                HSDAQNet.DATALOG.HS_GetLogFileInfo(hFile, ref name, ref fileLength, ref filetype, ref fileversion);
                Console.WriteLine(name + " " + fileLength + " " + filetype + " " + fileversion);
                HSDAQNet.DATALOG.HS_GetLogFile_AIScanConfigInfo(hFile, ref CHs, ref gain, ref mode, ref rate, ref transmode, ref sync);
                Console.WriteLine(CHs + " " + gain + " " + mode + " " + rate + " " + transmode + " " + sync);
                HSDAQNet.DATALOG.HS_GetLogFile_AIScanSampleInfo(hFile, ref sample_cnt, ref date, ref time);
                Console.WriteLine(sample_cnt + " " + date + " " + time);
                HEX_Data = new Int32[sample_cnt];
                float_Data = new float[sample_cnt];

                Gain_Value = new ushort[CHs];
                Offset_Value = new short[CHs];
                for (i = 0; i < CHs; i++)
                {
                    HSDAQNet.DATALOG.HS_GetLogFile_GainOffset(hFile, i, gain, ref Gain_Value[i], ref Offset_Value[i]);
                }
                switch (filetype)
                {
                    case 0:
                        HSDAQNet.DATALOG.HS_GetLogFile_AIDataHex(hFile, 0, sample_cnt, HEX_Data);
                        for (i = 0; i < fileLength / 4; i++)
                        {
                            HSDAQNet.IO.HS_Calibrate_Data_Float(hFile, i % CHs, 0, (Int32)HEX_Data[i], ref float_Data[i]);
                        }
                        break;
                    case 1:
                        HSDAQNet.DATALOG.HS_GetLogFile_AIData(hFile, 0, sample_cnt, float_Data);
                        break;
                    case 2:
                        break;
                    case 3:
                        HSDAQNet.DATALOG.HS_GetLogFile_AIData(hFile, 0, sample_cnt, float_Data);
                        break;
                    case 4:
                        HSDAQNet.DATALOG.HS_GetLogFile_AIDataHex(hFile, 0, sample_cnt, HEX_Data);
                        for (i = 0; i < sample_cnt; i++)
                        {
                            float_Data[i] = (float)((float)(((float)HEX_Data[i]) / (float)2147483647) * range[0]);
                        }
                        break;
                }
                HSDAQNet.DATALOG.HS_LogFile_Close(hFile);
                Data_View_dgv.Rows.Clear();
                Data_View_dgv.ColumnCount = CHs + 1;
                Data_View_dgv.Columns[0].Name = "Index";
                Data_View_dgv.Columns[0].Width = 50;
                for (i = 0; i < CHs; i++)
                {
                    Data_View_dgv.Columns[i + 1].Name = "Ch" + i.ToString();
                    Data_View_dgv.Columns[i + 1].Width = 75;
                    Application.DoEvents();
                }

                for (i = 0; i < sample_cnt / CHs; i++)
                {
                    Split_Part[0] = i.ToString();
                    for (j = 0; j < CHs; j++)
                    {
                        Split_Part[j + 1] = float_Data[i * CHs + j].ToString();
                    }
                    Data_View_dgv.Rows.Add(Split_Part);
                    Application.DoEvents();
                }
            }
            else
            {
                return;
            }
        }
    }
}